package de.digisalt.tileEdit.controller;

import de.digisalt.tileEdit.model.CurrentData;
import de.digisalt.tileEdit.model.Model;
import de.digisalt.tileEdit.view.components.StatusBar;
import de.digisalt.tileEdit.view.windows.MainWindow;

public class Controller {
	
	private static Controller instance = null;
	
	private Controller()
	{}
	
	public static Controller getInstance()
	{
		if (instance == null)
		{
			instance = new Controller();
		}
		return instance;
	}
	
	public void viewToModel(int cmd, Object[] obj)
	{
		switch (cmd)
		{
			case Commands.testCommand:
			{
				
				break;
			}
			case Commands.v2mSaveGraphicToFile:
			{
				Model.getInstace().saveDataToFile((String)obj[0]);
				break;
			}
			case Commands.v2mCloseFile:
			{
				CurrentData.getInstance().removeAllTiles();
				CurrentData.getInstance().setCurrentFileNameAndPath(null);
				this.modelToView(Commands.m2vUpdateTiles, null);
				this.modelToView(Commands.m2vShowStatusMessage, new Object[] {new Integer(StatusBar.STATUS_NONE), "File closed."});
				break;
			}
			case Commands.v2mNewFile:
			{
				Model.getInstace().newFile(((Integer)obj[0]).intValue(), ((Integer)obj[1]).intValue());
				this.viewToModel(Commands.v2mSetNumberOfColumns, new Object[] {obj[1]});
				break;
			}
			case Commands.v2mScrollUpUp:
			{
				CurrentData.getInstance().decreaseFirstDisplayedTileByCol();
				Controller.getInstance().modelToView(Commands.m2vUpdateTiles, null);
				break;
			}
			case Commands.v2mScrollUp:
			{
				CurrentData.getInstance().decreaseFirstDisplayedTileByOne();
				Controller.getInstance().modelToView(Commands.m2vUpdateTiles, null);
				break;
			}
			case Commands.v2mScrollDown:
			{
				CurrentData.getInstance().increaseFirstDisplayedTileByOne();
				Controller.getInstance().modelToView(Commands.m2vUpdateTiles, null);
				break;
			}
			case Commands.v2mScrollDownDown:
			{
				CurrentData.getInstance().increaseFirstDisplayedTileByCol();
				Controller.getInstance().modelToView(Commands.m2vUpdateTiles, null);
				break;
			}
			case Commands.v2mSetNumberOfColumns:
			{
				MainWindow.getInstance().setColSelection(((Integer)obj[0]).intValue());
				CurrentData.getInstance().setNumOfCols(((Integer)obj[0]).intValue());
				Controller.getInstance().modelToView(Commands.m2vUpdateTiles, null);
				Controller.getInstance().modelToView(Commands.m2vRepaintAllObjectsOnTileEditor, null);
				break;
			}
			case Commands.v2mLoadGraphicIntoEditor:
			{
				Model.getInstace().loadFileIntoEditor((String)obj[0]);
				break;
			}
			case Commands.v2mLoadPaletteIntoEditor:
			{
				Model.getInstace().loadPaletteIntoEditor((String)obj[0]);
				break;
			}
			case Commands.v2mInit:
			{
				Model.getInstace().newFile(16, 16);
				break;
			}
			case Commands.v2mSetCurrentRedValue:
			{
				CurrentData.getInstance().setLeftColorRedVal(((Integer)obj[0]).intValue());
				break;
			}
			case Commands.v2mSetCurrentGreenValue:
			{
				CurrentData.getInstance().setLeftColorGreenVal(((Integer)obj[0]).intValue());
				break;
			}
			case Commands.v2mSetCurrentBlueValue:
			{
				CurrentData.getInstance().setLeftColorBlueVal(((Integer)obj[0]).intValue());
				break;
			}
			case Commands.v2mNewLeftButtonColorSelected:
			{
				CurrentData.getInstance().setCurrentLeftColorNumber(((Integer)obj[0]).intValue());
				this.modelToView(Commands.m2vSetNewSelectedLeftColor, obj);
				break;
			}
			case Commands.v2mNewRightButtonColorSelected:
			{
				CurrentData.getInstance().setCurrentRightColorNumber(((Integer)obj[0]).intValue());
				this.modelToView(Commands.m2vSetNewSelectedRightColor, obj);
				break;
			}
			default:
			{
				System.out.println("Controller: Invalid viewToModel Command received " + cmd);			
			}
		}
	}
	
	public void modelToView(int cmd, Object[] obj)
	{
		switch (cmd)
		{
			case Commands.testCommand:
			{
				break;
			}
			case Commands.m2vShowStatusMessage:
			{
				MainWindow.getInstance().setStatusMessage(((Integer)obj[0]).intValue(), (String)obj[1]);
				break;
			}
			case Commands.m2vShowAlert:
			{
				MainWindow.getInstance().showAlert((String)obj[0]);
				break;
			}
			case Commands.m2vInit:
			{
				modelToView(Commands.m2vSetNewSelectedLeftColor, new Object[]{new Integer(0)});
				break;
			}
			case Commands.m2vShowMainWindow:
			{
				MainWindow.getInstance().setVisible(true);
				break;
			}
			case Commands.m2vHideMainWindow:
			{
				MainWindow.getInstance().setVisible(false);
				break;
			}
			case Commands.m2vRepaintAllObjectsOnTileEditor:
			{
				MainWindow.getInstance().repaint();
				break;
			}
			case Commands.m2vRepaintArrangerOnly:
			{
				MainWindow.getInstance().repaintArranger();
				break;				
			}
			case Commands.m2vRepaintColorAdjustersOnly:
			{
				MainWindow.getInstance().repaintAdjusters();
				break;
			}
			case Commands.m2vRepaintPaletteOnly:
			{
				MainWindow.getInstance().repaintPalette();
				break;
			}
			case Commands.m2vRepaintTileSourceOnly:
			{
				MainWindow.getInstance().repaintTileSource();
				break;
			}
			case Commands.m2vRepaintBigTileOnly:
			{
				MainWindow.getInstance().repaintBigTile();
				break;
			}
			case Commands.m2vSetNewSelectedLeftColor:
			{
				MainWindow.getInstance().setNewSelectedLeftColor(((Integer)obj[0]).intValue());
				break;
			}
			case Commands.m2vSetNewSelectedRightColor:
			{
				MainWindow.getInstance().setNewSelectedRightColor(((Integer)obj[0]).intValue());
				break;
			}
			case Commands.m2vUpdateTiles:
			{
				MainWindow.getInstance().setNewLoadedTiles();
				break;
			}
			default:
			{
				System.out.println("Controller: Invalid modelToView Command received " + cmd);			
			}
		}
	}
}
