package de.digisalt.tileEdit.view.components;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JPanel;

import de.digisalt.tileEdit.controller.Commands;
import de.digisalt.tileEdit.controller.Controller;
import de.digisalt.tileEdit.model.CurrentData;
import de.digisalt.tileEdit.model.dataContainers.AbstractPaletteContainer;

@SuppressWarnings("serial")
public class ColorSelectionPanel extends JPanel {
	private AbstractPaletteContainer pal = null;
	private int leftIndex = 0;
	private int rightIndex = 1;
	
	public ColorSelectionPanel()
	{
		pal = CurrentData.getInstance().getCurrentPalette();	
	}
	
	public ColorSelectionPanel(AbstractPaletteContainer pal)
	{
		this.pal = pal;
	}

	public int getLeftIndex()
	{
		return leftIndex;
	}
	
	public int getRightIndex()
	{
		return rightIndex;
	}
	
	public void setLeftIndex(int i) throws Exception
	{
		if (i < 0 || i > 15)
		{
			throw new Exception();
		}
		leftIndex = i;
	}
	
	public void setRightIndex(int i) throws Exception
	{
		if (i < 0 || i > 15)
		{
			throw new Exception();
		}
		rightIndex = i;
	}
	
	public void setPalette(AbstractPaletteContainer pal)
	{
		this.pal = pal;
	}
	
	public void paintComponent(Graphics g) 
	{
		super.paintComponent(g);       
		
		try 
		{
			//Draw Right Rectangles
			g.setColor(pal.getColor(rightIndex));
			g.fillRect(22, 36, 42, 42);
			g.setColor(new Color(0,0,0));
			g.drawRect(22, 36, 42, 42);
			//Draw Left Rectangles
			g.setColor(pal.getColor(leftIndex));
			g.fillRect(0, 16, 42, 42);
			g.setColor(new Color(0,0,0));
			g.drawRect(0, 16, 42, 42);
		} 
		catch (Exception e) 
		{
			Controller.getInstance().modelToView(Commands.m2vShowAlert, new Object[]{"Error painting ColorSelectionPanel"});
		}
	}  
}
